local folder, core = ...

local module = core:NewModule("Blizzard", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale(folder, true)

module.name = "Blizzard"
module.desc = "Unknown"
module.barMod = true

local regEvents = {
--~ 	"DUEL_REQUESTED",
}


function module:OnInitialize()
--~ 	Debug("Duel", "OnInitialize")	
	
	self.db = core.db:RegisterNamespace(module.name, {
		profile = {
			moduleEnabled = true,
--~ 			sound = "ATT alert",
			hideBarBackground = true,
		},
	})
	
	if not self.db.profile.moduleEnabled then
		self:SetEnabledState(false)
	end
end

do
	local pairs = pairs
	function module:OnEnable()
	--~ 	Debug("Duel", "OnEnable")
	
		for i, event in pairs(regEvents) do 
			self:RegisterEvent(event)
		end
--~ 		if core.db.profile.dimCombatOnly == false then
--~ 			self:HookActionButtons()
--~ 		end
		
		if self.db.profile.hideBarBackground == true then
			self:HideBackgrounds(0)
		else
			self:HideBackgrounds(1)
		end
		
	end
end


local name = function(info) 
	local key = info[#info]
--~ 	return key
	return L[key.."Name"] and L[key.."Name"]:format(module.db.profile[key]) or key
end
local desc = function(info) 
	local key = info[#info]
--~ 	return key
	return L[key.."Desc"] and L[key.."Desc"]:format(module.db.profile[key]) or key
end

do
	local ENABLE = ENABLE
	function module:GetOptions()
		return {
			name = self.name,
			type = "group",
			get = function(info)
				local key = info[#info]
				return self.db.profile[key]
			end,
			set = function(info, v)
				local key = info[#info]
				self.db.profile[key] = v
				self:Disable()
				self:Enable()
			end,
			args = {
				Desc = {
					type = "description",
					name = self.desc,
					order = 1,
				},
				moduleEnabled = {
					type = "toggle",	order	= 10,
					name	= ENABLE,
					desc	= desc,
					set = function(info, v)
						self.db.profile.moduleEnabled = v 
						if v == true then
							self:Enable()
						else
							self:Disable()
						end
					end,
				},
				hideBarBackground = {
					type = "toggle",	order	= 11,
					name	= name,
					desc	= desc,
				},
				
				
--~ 				sound = {
--~ 					type = 'select',	 order	= 11,
--~ 					dialogControl = 'LSM30_Sound', --Select your widget here
--~ 					values = LSM:HashTable('sound'), -- pull in your font list from LSM
--~ 					name = L["Sound"],
--~ 					desc = L["Sound to play"],
--~ 				},
			}
		}
	end
end

------------
local blizBars = {
	"MultiBarBottomRight",
	"MultiBarBottomLeft",
	"MultiBarRight",
	"MultiBarLeft",
	"BonusAction",
	"Action",
}

do
	local NUM_ACTIONBAR_BUTTONS = NUM_ACTIONBAR_BUTTONS
	local pairs = pairs
	local _G = _G
	

	--------------------------------------
	function module:HookActionButtons()		--
	-- Hook action button's OnUpdate.	--
	--------------------------------------
		for _, barName in pairs(blizBars) do 
			for i=1, NUM_ACTIONBAR_BUTTONS, 1 do
				core:HookActionButton(_G[barName.."Button"..i], barName, i)
			end
		end
		
	end
end

function module:OnDisable()
	self:UnhookAllBars()
end

do
	local pairs = pairs
	----------------------------------------------------------------------
	function module:UnhookAllBars()											--
	-- Unhook all bars, this also returns action buttons to 100% alpha.	--
	----------------------------------------------------------------------
--~ 		Debug("UnhookAllBars")
	--~ 	if BT4 == true then
	--~ 		for i=1, 10 do 
	--~ 			UnhookBar("BT4Bar"..i)
	--~ 		end
	--~ 		
	--~ 	elseif Dominos == true then
	--~ 		for i=1, 10 do 
	--~ 			UnhookBar("dBar"..i)
	--~ 		end
	--~ 		
	--~ 	else
	--~ 		self:UnhookBar("Bar1")
	--~ 		self:UnhookBar("BonusBar1")
	--~ 		self:UnhookBar("MultiBarBottomLeft")
	--~ 		self:UnhookBar("MultiBarBottomRight")
	--~ 		self:UnhookBar("MultiBarRight")
	--~ 		self:UnhookBar("MultiBarLeft")
			
		for _, barName in pairs(blizBars) do 
			core:UnhookBar(barName)
		end
	--~ 	end
	end
end

do
	local _G = _G
	--Grab the button's iron below a bonus action button.
	local underButtonName, underButton
	module.underIcon = setmetatable({}, {
		__index = function(t,button)
			local underButtonName = "ActionButton"..button:GetID()
			local underButton = _G[underButtonName]
			t[button] = _G[underButtonName.."Icon"] or underButton:GetNormalTexture()
--~ 			print("underIcon", button, button:GetName(), underButton:GetName())
			return t[button]
		end
	})
end

do
	local _G = _G
	--~ /run MainMenuBarArtFrame:SetAlpha(1)
	function module:HideBackgrounds(alpha)--	/run _DA:HideBackgrounds(0)
	--~ 	Debug("HideBackgrounds", alpha)
		--/run _G["BonusActionBarFrameTexture1"]:SetVertexColor(1,1,1,0)
		for i=1, 2 do 
			_G["BonusActionBarFrameTexture"..i]:SetVertexColor(1,1,1,alpha)
	--~ 		_G["ActionBarFrameTexture"..i]:SetVertexColor(1,1,1,alpha)
			
	--~ 		_G["MainMenuBarTexture"..i]:SetVertexColor(1,1,1,alpha)
	--~ 		_G["MainMenuBarTexture"..i]:SetVertexColor(1,1,1,alpha)
		end
		
		for i=0, 1 do 
			_G["MainMenuBarTexture"..i]:SetVertexColor(1,1,1,alpha)
		end
	end
end

function module:UpdateActionButton(button, name, icon)
	if name:find("BonusAction") then
		self.underIcon[button]:SetVertexColor(1,1,1, 0, true)
	elseif name:find("ActionButton") and GetBonusBarOffset() > 0 then
		icon:SetVertexColor(1,1,1, 0, true)
		return true
	end
end